
SuperStrict

Import Openb3d.B3dglgraphics

Const CSG_SUBTRACT:Int	= 0 ' Method 0 subtracts mesh2 from mesh1
Const CSG_ADD:Int		= 1 ' Method 1 adds meshes
Const CSG_INTERSECT:Int	= 2 ' Method 2 intersects meshes

Graphics3D 1024, 768, 0, 2

Local cam:TCamera	= CreateCamera ()

	MoveEntity cam, -2, 5, 0
	
Local pivot:TPivot = CreatePivot ()

	MoveEntity pivot, 0, 0, 5

Local light:TLight	= CreateLight ()

	MoveEntity light, -10, 0, 0
	
Local cube1:TMesh	= CreateCube ()

	MoveEntity	cube1, -0.5, -0.5, 5

Local cube2:TMesh	= CreateCube ()

	MoveEntity	cube2, 0.5, 0.5, EntityZ (cube1) - 0.5

Local cube:TMesh

PointEntity cam, pivot
PointEntity light, pivot

Local cubealpha:Float	= 1.0
Local fadeout:Float		= 0.01

Local csgalpha:Float = 0.0
Local csgfadein:Float = 0.05

Local timer:Int = MilliSecs ()

Repeat

	Cls
	
	If cube
		
		TurnEntity cube, -0.25, -0.05, -0.25
		
		csgalpha = csgalpha + csgfadein
		If csgalpha => 1.0 Then csgalpha = 1.0
		EntityAlpha cube, csgalpha
		
		cubealpha = cubealpha - fadeout
		If cubealpha <= 0.0 Then cubealpha = 0.0
		
		EntityAlpha cube1, cubealpha

		cubealpha = cubealpha - fadeout
		If cubealpha <= 0.0 Then cubealpha = 0.0
		
		EntityAlpha cube2, cubealpha
		
		MoveEntity cube1, 0.0, -0.05, 0.01
		MoveEntity cube2, 0.05, 0.05, -0.05
		
	EndIf

	If KeyHit (KEY_EQUALS) Or KeyHit (KEY_NUMADD)
	
		If cube

			FreeEntity cube
			cube = Null

			cubealpha = 1.0

			EntityAlpha cube1, cubealpha
			EntityAlpha cube2, cubealpha

			PositionEntity cube1, -0.5, -0.5, 5
			PositionEntity cube2, 0.5, 0.5, EntityZ (cube1) - 0.5

		EndIf

		cube = cube1 + cube2

		If cube
			
			CenterMesh cube
			EntityColor cube, 255, 0, 0

			csgalpha = 0
			EntityAlpha cube, csgalpha

			PositionEntity cube, 0.0, 0.0, 4.75 ' Not tried to work out why 4.75!
	
		EndIf
		
		timer = MilliSecs ()
		
	EndIf

	If KeyHit (KEY_MINUS) Or KeyHit (KEY_NUMSUBTRACT)
	
		If cube

			FreeEntity cube
			cube = Null

			cubealpha = 1.0

			EntityAlpha cube1, cubealpha
			EntityAlpha cube2, cubealpha

			PositionEntity cube1, -0.5, -0.5, 5
			PositionEntity cube2, 0.5, 0.5, EntityZ (cube1) - 0.5

		EndIf

		cube = cube1 - cube2

		If cube
			
			CenterMesh cube
			EntityColor cube, 0, 0, 255

			csgalpha = 0
			EntityAlpha cube, csgalpha
			
			PositionEntity cube, -0.5, -0.5, 5
		
		EndIf

		timer = MilliSecs ()

	EndIf

	If KeyHit (KEY_SLASH) Or KeyHit (KEY_NUMDIVIDE)
	
		If cube

			FreeEntity cube
			cube = Null

			cubealpha = 1.0

			EntityAlpha cube1, cubealpha
			EntityAlpha cube2, cubealpha

			PositionEntity cube1, -0.5, -0.5, 5
			PositionEntity cube2, 0.5, 0.5, EntityZ (cube1) - 0.5

		EndIf

		cube = cube1 & cube2

		If cube
			
			CenterMesh cube
			EntityColor cube, 255, 0, 0

			csgalpha = 0
			EntityAlpha cube, csgalpha

			PositionEntity cube, 0.0, 0.0, 4.75 ' Not tried to work out why 4.75!
	
		EndIf
		
		timer = MilliSecs ()
		
	EndIf

	If MilliSecs () - timer > 3000

		If cube

			FreeEntity cube
			cube = Null

			cubealpha = 1.0

			EntityAlpha cube1, cubealpha
			EntityAlpha cube2, cubealpha

			PositionEntity cube1, -0.5, -0.5, 5
			PositionEntity cube2, 0.5, 0.5, EntityZ (cube1) - 0.5

		EndIf

	EndIf
	
	RenderWorld
	
	BeginMax2D
	
		DrawText "Press + to add meshes, - to subtract, / to apply AND operator...", 20, 20
	
	EndMax2D
	
	Flip
	
Until KeyHit (KEY_ESCAPE) Or AppTerminate ()

End

Function CenterMesh:Int (entity:TMesh)
	FitMesh entity, -(MeshWidth (entity) / 2.0), -(MeshHeight (entity) / 2.0), -(MeshDepth (entity) / 2), MeshWidth (entity), MeshHeight (entity), MeshDepth (entity)
End Function
